"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _codeSurfer = _interopRequireDefault(require("code-surfer"));

var _react = _interopRequireDefault(require("react"));

var _mdxDeck = require("mdx-deck");

var _context = require("mdx-deck/dist/context");

var _Slide = require("mdx-deck/dist/Slide");

var _temp;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = (0, _context.withDeck)((0, _Slide.withSlide)((_temp =
/*#__PURE__*/
function (_React$Component) {
  _inherits(_temp, _React$Component);

  function _temp() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, _temp);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(_temp)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "handleKeyDown", function (e) {
      if (e.metaKey || e.ctrlKey || e.shiftKey || e.altKey) return;
      if (_this.props.deck.index !== _this.props.slide.index) return;
      var update = _this.props.deck.update;

      switch (e.key) {
        case "ArrowDown":
          e.preventDefault();
          update((0, _mdxDeck.incStep)(_this.props.stepsTop));
          break;

        case "ArrowUp":
          e.preventDefault();
          update((0, _mdxDeck.decStep)());
          break;
      }
    });

    return _this;
  }

  _createClass(_temp, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      document.body.addEventListener("keydown", this.handleKeyDown);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      document.body.removeEventListener("keydown", this.handleKeyDown);
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      return this.props.deck.index === this.props.slide.index;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          codeTop = _this$props.codeTop,
          codeBottom = _this$props.codeBottom,
          stepsTop = _this$props.stepsTop,
          stepsBottom = _this$props.stepsBottom,
          title = _this$props.title,
          showNumbers = _this$props.showNumbers,
          notes = _this$props.notes;
      var _this$props$deck = this.props.deck,
          step = _this$props$deck.step,
          mode = _this$props$deck.mode;
      var currentStepTop = step < 0 ? {
        notes: notes
      } : stepsTop[step] || stepsTop[0];
      var currentStepBottom = step < 0 ? {
        notes: notes
      } : stepsBottom[step] || stepsBottom[0];
      var topSize = codeTop.split("\n").length - 1;
      var bottomSize = codeBottom.split("\n").length - 1;
      return _react["default"].createElement("div", {
        style: {
          height: "100vh",
          display: "flex",
          flexDirection: "column"
        }
      }, _react["default"].createElement("div", {
        style: {
          flex: topSize,
          overflow: "hidden"
        },
        key: "codeTop"
      }, _react["default"].createElement(_codeSurfer["default"], {
        code: codeTop,
        step: currentStepTop,
        showNumbers: showNumbers
      })), _react["default"].createElement("div", {
        style: {
          height: "25px"
        }
      }), _react["default"].createElement("div", {
        style: {
          flex: bottomSize,
          overflow: "hidden"
        },
        key: "codeBottom"
      }, _react["default"].createElement(_codeSurfer["default"], {
        code: codeBottom,
        step: currentStepBottom,
        showNumbers: showNumbers
      })), _react["default"].createElement("div", {
        style: {
          height: "25px"
        }
      }));
    }
  }]);

  return _temp;
}(_react["default"].Component), _temp)));

exports["default"] = _default;